



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>ElasticSearch文档操作介绍三</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">ElasticSearch文档操作介绍三</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 00:26:14 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>ElasticSearch文档的操作</strong></p>
<p>文档存储位置的计算公式:</p>
<div>
<pre class="prettyprint linenums">shard = hash(routing) % number_of_primary_shards</pre>
</div>
<p>上面公式中，routing 是一个可变值，默认是文档的 _id ，也可以设置成一个自定义的值。 routing 通过 hash 函数生成一个数字，然后这个数字再除以 number_of_primary_shards （主分片的数量）后得到 余数 。这个分布在 0 到 number_of_primary_shards-1 之间的余数，就是我们所寻求的文档所在分片的位置。</p>
<p>这就解释了为什么我们要在创建索引的时候就确定好主分片的数量 并且永远不会改变这个数量：因为如果数量变化了，那么所有之前路由的值都会无效，文档也再也找不到了。</p>
<p>所有的文档 API（ get 、 index 、 delete 、 bulk 、 update 以及 mget ）都接受一个叫做 routing 的路由参数 ，通过这个参数我们可以自定义文档到分片的映射。一个自定义的路由参数可以用来确保所有相关的文档&mdash;&mdash;例如所有属于同一个用户的文档&mdash;&mdash;都被存储到同一个分片中。</p>
<p>ElasticSearch中，新建、删除、索引文档都属于写操作，必须在主分片上面完成之后才能被复制到相关的副本分片。</p>
<p><strong>写一个文档:</strong></p>
<p>下图是官网的一个例子，假设集群中有三个节点，一个索引，两个主分片，每个主分片有两个副本。写操作一个文档的过程如下:</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/693253/201801/693253-20180116155404287-1450575914.png" /></p>
<p>1、客户端向 Node 1 发送新建、索引或者删除请求。<br />2、节点使用文档的 _id 确定文档属于分片 0 。请求会被转发到 Node 3`，因为分片 0 的主分片目前被分配在 `Node 3 上。<br />3、Node 3 在主分片上面执行请求。如果成功了，它将请求并行转发到 Node 1 和 Node 2 的副本分片上。一旦所有的副本分片都报告成功, Node 3 将向协调节点(接受客户端请求的节点)报告成功，协调节点向客户端报告成功。</p>
<p>在客户端收到成功响应时，文档变更已经在主分片和所有副本分片执行完成，变更是安全的。</p>
<p><strong>读一个文档:</strong></p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/693253/201801/693253-20180116162443287-425510239.png" /></p>
<p>检索(读取)一个文档时，可以从主分片或者其他任意副本分区检索。</p>
<p>以下是从主分片或者副本分片检索文档的步骤顺序：</p>
<p>1、客户端向 Node 1 发送获取请求。</p>
<p>2、节点使用文档的 _id 来确定文档属于分片 0 。分片 0 的主、副分片存在于所有节点上。 在这种情况下，它将请求转发到 Node 2 。</p>
<p>3、Node 2 将文档返回给 Node 1 ，然后将文档返回给客户端。</p>
<p>在处理读取请求时，协调结点在每次请求的时候都会通过轮询所有的副本分片来达到负载均衡。</p>
<p>在文档被检索时，已经被索引的文档可能已经存在于主分片上但是还没有复制到副本分片。 在这种情况下，副本分片可能会报告文档不存在，但是主分片可能成功返回文档。 一旦索引请求成功返回给用户，文档在主分片和副本分片都是可用的。</p>
<p><strong>部分更新一个文档:</strong></p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/693253/201801/693253-20180116164353662-606217298.png" /><em>&nbsp;</em></p>
<p>以下是部分更新一个文档的步骤：</p>
<p>1、客户端向 Node 1 发送更新请求。<br />2、它将请求转发到主分片所在的 Node 3 。<br />3、Node 3 从主分片检索文档，修改 _source 字段中的 JSON ，并且尝试重新索引主分片的文档。 如果文档已经被另一个进程修改，它会重试步骤 3 ，超过 retry_on_conflict 次后放弃。<br />4、如果 Node 3 成功地更新文档，它将新版本的文档并行转发到 Node 1 和 Node 2 上的副本分片，重新建立索引。 一旦所有副本分片都返回成功， Node 3 向协调节点也返回成功，协调节点向客户端返回成功。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/49g45wl9.html">解决Windows下网络原因Composer安装失败问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyo1n28.html">iOS之 APNs全新的APNs苹果15年WWDC大会上的干货</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j5vnl8.html">ArrayList 与 LinkedList</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd4og2q.html">Supports BorlandIDEServices</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmrd0l9.html">NPOI的版本查看</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvpey1q.html">easyui常用控件样式收藏</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k165n69.html">Windows与Linux下文件操作监控的实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmv14e9.html">openerp 中如何方便对搜索时间段</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xk65m8.html">Build Android-x86 ICS 4 Virtualbox from Google Virtualbox Target and Intel Kernel 编译体验</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rde4mm8.html">Taurus&period;MVC</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vz00m8.html">Java编程的23种设计模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpmmkr9.html">Android 内存监测工具 DDMS --&amp;gt&semi; Heap（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey516m9.html">JAVA基础-多态</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk5vkd8.html">CSS 简单了解&lpar;二&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/96plr4n8.html">Dubbo与Zookeeper、SpringMVC整合和使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1g2k1q.html">XV Open Cup named after E&period;V&period; Pankratiev&period; GP of Three Capitals</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyj7od9.html">17&sol;11&sol;24 05&colon;08&colon;44 WARN util&period;NativeCodeLoader&colon; Unable to load native-hadoop library for your platform&period;&period;&period; using builtin-java classes where applicable</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wn01wq.html">CSS规范 - 分类方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwz54x9.html">使用requests进行模拟登陆</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1lr0g9.html">laravel框架基础（2）---laravel项目加载机制</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qwvxzxz8.html">第三个spring冲刺第2天</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwll579.html">9-Python3从入门到实战&mdash;基础之条件控制语句</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7o3wpx8.html">Docker-Compose 安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25v1joq.html">remove&lpar;&rpar;与empty&lpar;&rpar;的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5mlmrq.html">python主成分分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e42l3x9.html">Delphi中统一显示表格字段名的高效方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2z742q.html">html 框架 內聯框架</a>
			</li>
						<li><a href="https://www.batexi.com/a/960gr0y9.html">JavaScript&mdash;&mdash;AJAX</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7o35vj8.html">我的Linux系统九阴真经</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rlgln9.html">BZOJ2212 POI2011Tree Rotations（线段树合并）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
